#include <iostream>
#include <vector>
#include <math.h>
#include "histogram.h"
#include "text.h"
#include "svg.h"
#include <curl/curl.h>
#include <sstream>
#include <string>


using namespace std;

struct Input
{
    vector<double>numbers;
    size_t kol_kor{};
    size_t number_count;
};

size_t write_data(void* items, size_t item_size, size_t item_count, void* ctx)
{
    size_t data_size = item_size * item_count;
    stringstream* buffer = reinterpret_cast<stringstream*>(ctx);
    buffer->write(reinterpret_cast<const char*>(items), data_size);
    return data_size;
}

Input
input_data(istream& in, bool promt)
{
    Input ik;

    size_t number_count;
    if (promt)
    {
        cerr<<"Marks: ";
    }
    in>>ik.number_count;


    ik.numbers.resize(ik.number_count);
    for (size_t i=0; i<ik.number_count; i++)
    {
        cerr<<"numbers["<<i<<"]=";
        in>>ik.numbers[i];
    }

    cerr<<"Kol_kor: ";
    in>>ik.kol_kor;
    return ik;
}


Input
download(const string& address)
{
    stringstream buffer;
    CURL* curl = curl_easy_init();
    if(curl)
    {
        CURLcode res;
        curl_easy_setopt(curl, CURLOPT_URL, address.c_str());
        curl_easy_setopt(curl, CURLOPT_WRITEFUNCTION, write_data);
        curl_easy_setopt(curl, CURLOPT_WRITEDATA, &buffer);
        res = curl_easy_perform(curl);
        if (res != 0)
        {
            cout << curl_easy_strerror(res);
            exit(1);
        }

        curl_easy_cleanup(curl);
    }
    return input_data(buffer, false);
}

int main(int argc, char* argv[])
{
    Input in;
    if (argc > 1)
    {
        in = download(argv[1]);
    }
    else
    {
        in = input_data(cin, true);
    }

    size_t number_count;
    auto B = make_histogram(in.numbers, in.kol_kor);
    show_histogram_svg(B, in.number_count);

    return 0;
}
